.\" Copyright 1993 David Metcalfe (david@prism.demon.co.uk)
.\"
.\" Permission is granted to make and distribute verbatim copies of this
.\" manual provided the copyright notice and this permission notice are
.\" preserved on all copies.
.\"
.\" Permission is granted to copy and distribute modified versions of this
.\" manual under the conditions for verbatim copying, provided that the
.\" entire resulting derived work is distributed under the terms of a
.\" permission notice identical to this one
.\" 
.\" Since the Linux kernel and libraries are constantly changing, this
.\" manual page may be incorrect or out-of-date.  The author(s) assume no
.\" responsibility for errors or omissions, or for damages resulting from
.\" the use of the information contained herein.  The author(s) may not
.\" have taken the same level of care in the production of this manual,
.\" which is licensed free of charge, as they might when working
.\" professionally.
.\" 
.\" Formatted or processed versions of this manual, if unaccompanied by
.\" the source, must acknowledge the copyright and authors of this work.
.\"
.\" References consulted:
.\"     Linux libc source code
.\"     Lewine's _POSIX Programmer's Guide_ (O'Reilly & Associates, 1991)
.\"     386BSD man pages
.\" Modified Sun Jul 25 10:40:51 1993 by Rik Faith (faith@cs.unc.edu)
.\" Modified Sun Apr 14 16:20:34 1996 by Andries Brouwer (aeb@cwi.nl)
.TH SIGINTERRUPT 3  "April 13, 1993" "" "Linux Programmer's Manual"
.SH NAME
siginterrupt \- allow signals to interrupt system calls
.SH SYNOPSIS
.nf
.B #include <signal.h>
.sp
.BI "int siginterrupt(int " sig ", int " flag );
.fi
.SH DESCRIPTION
The \fBsiginterrupt()\fP function changes the restart behaviour when
a system call is interrupted by the signal \fIsig\fP.  If the \fIflag\fP 
argument is false (0), then system calls will be restarted if interrupted 
by the specified signal \fIsig\fP.  This is the default behaviour in
Linux.  However, when a new signal handler is specified with the
\fBsignal\fP(2) function, the system call is interrupted by default.
.PP
If the \fIflags\fP argument is true (1) and no data has been transferred,
then a system call interrupted by the signal \fIsig\fP will return \-1
and the global variable \fIerrno\fP will be set to \fBEINTR\fP.
.PP
If the \fIflags\fP argument is true (1) and data transfer has started,
then the system call will be interrupted and will return the actual
amount of data transferred.
.SH "RETURN VALUE"
The \fBsiginterrupt()\fP function returns 0 on success, or \-1 if the
signal number \fIsig\fP is invalid.
.SH "ERRORS"
.TP
.B EINVAL
The specified signal number is invalid.
.SH "CONFORMING TO"
BSD 4.3
.SH "SEE ALSO"
.BR signal (2)
